<?php
namespace Auction\Report;



/**
 * Stock Contyrol Report.
 * @author andre.fourie
 */
class BasketGrid extends \Utility\Service\Report
{



	/**
	 * @var string
	 */
	protected $_title  = 'Auction Basket Data Export';
	/**
	 * @var string
	 */
	protected $_subject = 'Vehicles on auction in basket.';
	/**
	 * @var string
	 */
	protected $_description = 'Export of vehicles on auction in basket.';
	/**
	 * @var array
	 */
	protected $_notes = array(
			'Confidential information, generated using Bid 4 Cars, for more information visit bid4cars.co.za'
			);
	/**
	 * @var array
	 */
	protected $_headers = array(
			'Seller',
			'Region',
			'Reference Number',
			'Registration Number',
			'VIN Number',
			'Make',
			'Model',
			'Type',
			'Year',
			'Main Exterior Colour',
			'KM',
			'Trade Price',
			'Retail Price',
			'Times listed on auction',
			'Highest Bid',
			'Status',
			'Created',
			'Updated'
			);
	/**
	 * @var array
	 */
	protected $_fields = array(
			'company_name',
			'region_name',
			'stock_referenceNumber',
			'stock_registrationNumber',
			'stock_vinNumber',
			'make_name',
			'model_name',
			'type_name',
			'vehicleYear_name',
			'exteriorColour_name',
			'stock_km',
			'stock_tradePrice',
			'stock_retailPrice',
            'stock_listPrice',
			'stock_timesListed',
			'stock_highestBid',
			'auction_jobState',
			'auction_created',
			'auction_updated'
			);
	/**
	 * @var array
	 */
	protected $_totals = array(
			'stock_tradePrice',
			'stock_retailPrice',
            'stock_listPrice',
			'stock_highestBid'
			);
	/**
	 * @var array
	 */
	protected $_currencyFields = array(
			'stock_tradePrice',
			'stock_retailPrice',
            'stock_listPrice',
			'stock_highestBid'
			);



	/**
	 * Build the dataset, or not.
	 */
	public function build()
	{
		#-> Data passed by DataBin Grid functionality.
		$dateTimeFormat = \Utility\Definitions\Locale::getDateTimeFormat();
		foreach ($this->_data as $rowId => $rowData)
		{
			$this->_data[$rowId]['auction_created'] = $rowData['auction_created']->format($dateTimeFormat);
			$this->_data[$rowId]['auction_updated'] = !is_null($rowData['auction_updated'])
				? $rowData['auction_updated']->format($dateTimeFormat)
				: '';
		}
	}

}
